=== util/post/Makefile ===
## SPDX-License-Identifier: GPL-2.0-only
all:
	$(CC) post.c -o post
clean:
	rm -f post

distclean: clean
