=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/,repacksuffix=+dfsg,dversionmangle=s/\+dfsg$// \
https://coreboot.org/releases/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
